\\
\\  Program to compute a Heegner point on curve e (=5160J1)
\\
default(echo,1)
default(realprecision,28)
e=ellinit( [0,-1,0,399549679,2496643493445] );
w1=e.omega[1]
n=ellglobalred(e)[1];
print("N = ",n);
nan=40000;
an=ellan(e,nan);
b=6677; d=-71; h=7; h0=4; ai=[1,2,3,4,5,8,10]
tau=(-b+sqrt(d))/(2*n)
qi=vector(h0,k,exp(2*Pi*I*tau/ai[k]))
xi=vector(h0,k,1)
si=vector(h0,k,0)
for(j=1,nan,cn=an[j]/j; \
for(k=1,h0,xi[k]*=qi[k]; si[k]+=cn*xi[k]));
s=real(si[1]+2*(si[2]+si[3]+si[4]));
z=(2*s+3*w1)/32
p=ellztopoint(e,z)
xp=bestappr(real(p[1]),10^10)
yp=ellordinate(e,xp)[1]
p=[xp,yp]
if(ellisoncurve(e,p),print("P = ",p,"\nHeight = ",ellheight(e,p)))


